<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";

import { useRouter } from "vue-router";
import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { usePositionTypeDataStore } from "@/modules/01_metadata/stores/positionTypeStore";

import type { QTableProps } from "quasar";

import dialogHeader from "@/components/DialogHeader.vue";

const $q = useQuasar();
const router = useRouter();
const store = usePositionTypeDataStore();
const {
  dialogConfirm,
  success,
  messageError,
  showLoader,
  hideLoader,
  onSearchDataTable,
  dialogRemove,
} = useCounterMixin();

// Table
const filterKeyword = ref<string>(""); //คำค้นหา
const columns = [
  {
    name: "posTypeName",
    align: "left",
    label: "ประเภทตำแหน่ง",
    sortable: true,
    field: "posTypeName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posTypeRank",
    align: "left",
    label: "ระดับตำแหน่ง",
    sortable: true,
    field: "posTypeRank",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่สร้าง",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
] as const satisfies QTableProps["columns"];
const visibleColumns = ref<string[]>([
  "posTypeName",
  "posTypeRank",
  "createdAt",
  "lastUpdatedAt",
  "lastUpdateFullName",
]);

const editId = ref<string>(""); // id รายกรปะเภทตำแหน่ง
const dialog = ref<boolean>(false); // modal popu เพิ่มข้อมูล,แก้ไข
const dialogStatus = ref<string>(""); // สถานการแก้ไข
const posTypeName = ref<string>(""); // ประเภทตำแหน่ง
const posTypeRank = ref<number | null>(null); // ระดับตำแหน่ง

/**
 * ดึงข้อมูลรายการประเภทตำแหน่ง
 * บันทึกข้อมูลรายการประเภทตำแหน่งใน Store positionTypeStore
 */
async function fetchData() {
  showLoader();
  await http
    .get(config.API.orgPosType)
    .then(async (res) => {
      await store.save(res.data.result);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ยืนยันการบันทึกข้อมูลประเภทตำแหน่ง
 * ุ ถ้า dialogStatus เป็น 'create' จะทำการเพิ่มข้อมูลรายการประเภทตำแหน่ง ถ่้าไม่จะทำการแก้ไขข้อมูล
 * เมื่อบันทึกข้อมูลเสร็จจะเรียก function fetchData() เพื่อดึงข้อมูลรายการประเภทตำแหน่งใหม่
 *
 */
function onSubmit() {
  if (posTypeName.value.length > 0 && posTypeRank.value !== null) {
    dialogConfirm($q, async () => {
      showLoader();
      // กำหนด Path API
      const path =
        dialogStatus.value === "create"
          ? config.API.orgPosType // เพิ่มรายการประเภทตำแหน่ง
          : config.API.orgPosTypeId(editId.value); // แก้ไขรายการประเภทตำแหน่ง

      // กำหนด method
      const method = dialogStatus.value === "create" ? "post" : "put";

      await http[method](path, {
        posTypeName: posTypeName.value,
        posTypeRank: posTypeRank.value,
      })
        .then(async () => {
          await fetchData();
          success($q, "บันทึกข้อมูลสำเร็จ");
          closeDialog();
        })
        .catch((err) => {
          messageError($q, err);
        })
        .finally(() => {
          hideLoader();
        });
    });
  }
}

/**
 * ลบข้อมูลประเภทตำแหน่ง
 * แล้ว fetch ข้อมูลรายการ ข้อมูลประเภทตำแหน่ง ใหม่
 * @param id ข้อมูลประเภทตำแหน่ง
 */
async function onDeleteData(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.orgPosTypeId(id))
      .then(async () => {
        await fetchData();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ปืด popup ฟอร์มประเภทตำแหน่ง
 * และเคลียร์ตัวแปรในฟอร์มประเภทตำแหน่ง
 */
function closeDialog() {
  dialog.value = false;
  posTypeName.value = "";
  posTypeRank.value = null;
}

/**
 * ไปหน้ารายการระดับของประเภทตำแหน่ง
 * @param id ของประเภทตำแหน่ง
 */
function onclickDetail(id: string) {
  router.push(`/master-data/position/level/${id}`);
}

function serchDataTable() {
  store.row = onSearchDataTable(
    filterKeyword.value,
    store.rowMain,
    columns ? columns : []
  );
}

/**
 * hook ทำงานเมื่อ Components ถูกเรียกใช้งาน
 */
onMounted(async () => {
  await fetchData();
});
</script>

<template>
  <q-toolbar style="padding: 0">
    <q-btn
      flat
      round
      color="primary"
      icon="add"
      @click.stop="
        () => {
          dialogStatus = 'create';
          dialog = true;
        }
      "
    >
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        dense
        outlined
        v-model="filterKeyword"
        placeholder="ค้นหา"
        @keydown.enter.prevent="serchDataTable"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>
  </q-toolbar>

  <d-table
    ref="table"
    :columns="columns"
    :rows="store.row"
    row-key="name"
    flat
    bordered
    :paging="true"
    dense
    class="custom-header-table"
    :visible-columns="visibleColumns"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr
        :props="props"
        class="cursor-pointer"
        @click.stop="onclickDetail(props.row.id)"
      >
        <q-td auto-width>
          <q-btn
            color="edit"
            flat
            dense
            round
            icon="edit"
            clickable
            @click.stop="
              () => {
                dialogStatus = 'edit';
                dialog = true;
                editId = props.row.id;
                posTypeName = props.row.posTypeName;
                posTypeRank = props.row.posTypeRank;
              }
            "
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            color="red"
            flat
            dense
            round
            icon="delete"
            @click.stop.prevent="onDeleteData(props.row.id)"
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td v-for="col in props.cols" :key="col.id">
          {{ col.value ?? "-" }}
        </q-td>
      </q-tr>
    </template>
  </d-table>

  <q-dialog v-model="dialog" class="dialog" persistent>
    <q-card style="min-width: 350px">
      <q-form greedy @submit.prevent @validation-success="onSubmit">
        <dialog-header
          :tittle="dialogStatus === 'edit' ? 'แก้ไขข้อมูล' : 'เพิ่มข้อมูล'"
          :close="closeDialog"
        />
        <q-separator />
        <q-card-section class="q-pa-none">
          <div class="col-12 q-ma-md">
            <q-input
              ref="posTypeNameRef"
              outlined
              v-model="posTypeName"
              label="ประเภทตำแหน่ง"
              dense
              lazy-rules
              borderless
              :rules="[(val:string) => val.length > 0 || 'กรุณากรอกประเภทตำแหน่ง']"
              hide-bottom-space
              class="inputgreen"
            />
          </div>
          <div class="col-12 q-ma-md">
            <q-input
              ref="posTypeRankRef"
              outlined
              v-model="posTypeRank"
              label="ระดับตำแหน่ง"
              dense
              lazy-rules
              borderless
              min="1"
              :rules="[(val:string) => val != undefined || 'กรุณากรอกระดับตำแหน่ง']"
              hide-bottom-space
              mask="############"
              class="inputgreen"
            />
          </div>
        </q-card-section>

        <q-separator />
        <q-card-actions align="right">
          <q-btn id="onSubmit" type="submit" label="บันทึก" color="public">
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>

<style scoped lang="scss"></style>
